package rip.tilly.bedwars.menus.shop.utilities;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import rip.tilly.bedwars.BedWars;
import rip.tilly.bedwars.menus.shop.ShopType;
import rip.tilly.bedwars.menus.shop.ShopTypeButton;
import rip.tilly.bedwars.utils.CC;
import rip.tilly.bedwars.utils.ItemBuilder;
import rip.tilly.bedwars.utils.menu.Button;
import rip.tilly.bedwars.utils.menu.Menu;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class UtilityMenu extends Menu {

    private BedWars main = BedWars.getInstance();

    @Override
    public boolean isUpdateAfterClick() {
        return true;
    }

    @Override
    public String getTitle(Player player) {
        return CC.translate("&eClick a utility to purchase...");
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<>();

        for (ShopType types : ShopType.values()) {
            buttons.put(types.getSlot(), new ShopTypeButton(types));
        }

        List<String> lore = new ArrayList<String>();

        buttons.put(ShopType.UTILITY.getSlot() + 9, Button.placeholder(Material.STAINED_GLASS_PANE, (byte) 5, ""));

        lore.add("Well rounded healing");

        buttons.put(19, new UtilityButton("Golden Apple", lore, Material.GOLDEN_APPLE, 0, 1, Material.GOLD_INGOT, "Gold", ChatColor.GOLD, 3, true));

        lore.clear();

        lore.add("Spawns a silverfish where the");
        lore.add("snowball lands to distract your");
        lore.add("enemies");

        buttons.put(20, new UtilityButton("Bed Bug", lore, Material.SNOW_BALL, 0, 1, Material.IRON_INGOT, "Iron", ChatColor.WHITE, 30, true));

        lore.clear();

        lore.add("Spawns an iron golem to help");
        lore.add("defend your base");

        buttons.put(21, new UtilityButton("Dream Defender", lore, Material.SNOW_BALL, 0, 1, Material.IRON_INGOT, "Iron", ChatColor.WHITE, 120, true));

        lore.clear();

        lore.add("Right click to throw a fireball");
        lore.add("at your enemies when they are currently");
        lore.add("walking on a bridge");

        buttons.put(22, new UtilityButton("Fireball", lore, Material.FIREBALL, 0, 1, Material.IRON_INGOT, "Iron", ChatColor.WHITE, 40, true));

        lore.clear();

        lore.add("Instantly ignites and is ready");
        lore.add("to explode things");

        buttons.put(23, new UtilityButton("TNT", lore, Material.TNT, 0, 1, Material.GOLD_INGOT, "Gold", ChatColor.GOLD, 4, true));

        lore.clear();

        lore.add("The fastest way to get");
        lore.add("to an enemy's base");

        buttons.put(24, new UtilityButton("Ender Pearl", lore, Material.ENDER_PEARL, 0, 1, Material.EMERALD, "Emerald", ChatColor.DARK_GREEN, 4, true));

        lore.clear();

        lore.add("Awesome for clutching");
        lore.add("and much more");

        buttons.put(25, new UtilityButton("Water Bucket", lore, Material.WATER_BUCKET, 0, 1, Material.GOLD_INGOT, "Gold", ChatColor.GOLD, 6, true));

        lore.clear();

        lore.add("Right click to throw an egg");
        lore.add("to then make a bridge in its");
        lore.add("trail");

        buttons.put(28, new UtilityButton("Bridge Egg", lore, Material.EGG, 0, 1, Material.EMERALD, "Emerald", ChatColor.DARK_GREEN, 1, true));

        lore.clear();

        lore.add("Avoid setting off a trap");
        lore.add("for thirty seconds");

        buttons.put(29, new UtilityButton("Magic Milk", lore, Material.MILK_BUCKET, 0, 1, Material.GOLD_INGOT, "Gold", ChatColor.GOLD, 4, true));

        lore.clear();

        lore.add("Awesome for distracting");
        lore.add("your enemies");

        buttons.put(30, new UtilityButton("Sponge", lore, Material.SPONGE, 0, 4, Material.GOLD_INGOT, "Gold", ChatColor.GOLD, 6, true));

        lore.clear();

        lore.add("Right click to make a");
        lore.add("popup tower");

        buttons.put(31, new UtilityButton("Popup Tower", lore, Material.CHEST, 0, 1, Material.IRON_INGOT, "Iron", ChatColor.WHITE, 24, true));

        lore.clear();

        this.fillEmptySlots(buttons, new ItemBuilder(Material.STAINED_GLASS_PANE).durability(7).name("").build());

        return buttons;
    }

    @Override
    public int getSize() {
        return 54;
    }
}
